package com.lyf.intentservice

import android.app.IntentService
import android.content.Context
import android.content.Intent
import java.util.*
import kotlin.concurrent.schedule

// TODO: Rename actions, choose action names that describe tasks that this
// IntentService can perform, e.g. ACTION_FETCH_NEW_ITEMS
private const val ACTION_FOO = "com.lyf.intentservice.action.FOO"
private const val ACTION_BAZ = "com.lyf.intentservice.action.BAZ"

// TODO: Rename parameters
private const val EXTRA_PARAM1 = "com.lyf.intentservice.extra.PARAM1"
private const val EXTRA_PARAM2 = "com.lyf.intentservice.extra.PARAM2"

/**
 * An [IntentService] subclass for handling asynchronous task requests in
 * a service on a separate handler thread.
 * TODO: Customize class - update intent actions, extra parameters and static
 * helper methods.
 */
class MyIntentService : IntentService("MyIntentService") {
    private val TAG = "IntentService"

    override fun onHandleIntent(intent: Intent?) {
        when (intent?.action) {
            ACTION_FOO -> {
                val param1 = intent.getStringExtra(EXTRA_PARAM1)
                val param2 = intent.getStringExtra(EXTRA_PARAM2)
                handleActionFoo(param1, param2)
            }
            ACTION_BAZ -> {
                val param1 = intent.getStringExtra(EXTRA_PARAM1)
                val param2 = intent.getStringExtra(EXTRA_PARAM2)
                handleActionBaz(param1, param2)
            }
        }
    }

    /**
     * Handle action Foo in the provided background thread with the provided
     * parameters.
     */
    private fun handleActionFoo(param1: String, param2: String) {
        println("$TAG param1: $param1 param2: $param2")
        /*var num = 0
        val timer = Timer()
        timer.schedule(0, 1000) {
            println("$TAG foo ${num++}")
            if (num == 10) {
                cancel()
            }
        }*/
        for (num in 1..1000) {
            println("$TAG foo $num")
        }
    }

    /**
     * Handle action Baz in the provided background thread with the provided
     * parameters.
     */
    private fun handleActionBaz(param1: String, param2: String) {
        println("$TAG param1: $param1 param2: $param2")
        /*var num = 0
        Timer().schedule(0, 1000) {
            println("$TAG baz ${num++}")
            if (num == 10) {
                cancel()
            }
        }*/
        for (num in 1..1000) {
            println("$TAG baz $num")
        }
        println()
    }

    companion object {
        /**
         * Starts this service to perform action Foo with the given parameters. If
         * the service is already performing a task this action will be queued.
         *
         * @see IntentService
         */
        // TODO: Customize helper method
        @JvmStatic
        fun startActionFoo(context: Context, param1: String, param2: String) {
            val intent = Intent(context, MyIntentService::class.java).apply {
                action = ACTION_FOO
                putExtra(EXTRA_PARAM1, param1)
                putExtra(EXTRA_PARAM2, param2)
            }
            context.startService(intent)
        }

        /**
         * Starts this service to perform action Baz with the given parameters. If
         * the service is already performing a task this action will be queued.
         *
         * @see IntentService
         */
        // TODO: Customize helper method
        @JvmStatic
        fun startActionBaz(context: Context, param1: String, param2: String) {
            val intent = Intent(context, MyIntentService::class.java).apply {
                action = ACTION_BAZ
                putExtra(EXTRA_PARAM1, param1)
                putExtra(EXTRA_PARAM2, param2)
            }
            context.startService(intent)
        }
    }
}
